/* ChessTask - A graphical frontend for creating chess tasks in
*              LaTeX or HTML.
* Copyright (C) 2002-2004 by Dirk Baechle (dl9obn@darc.de)
*
* http://chesstask.sourceforge.net
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the 
*
* Free Software Foundation, Inc.
* 675 Mass Ave
* Cambridge
* MA 02139
* USA
*
*/

/** 
\file ctTask.h
\author Dirk Baechle
\date 2004-03-24
\version 2.0
*/

#ifndef CT_TASK_H
#define CT_TASK_H

/*------------------------------------------------------------- Includes */

#include <qobject.h>
#include "ctPosition.h"

/*------------------------------------------- Forward class declarations */

class QString;

/*-------------------------------------------------------------- Classes */

/** This class \a ctTask contains all relevant data for a single
task, i.e. position, ``title'' text, ``task'' text and ``solution''
text.
*/
class ctTask: public QObject
{
    Q_OBJECT

public:
    ctTask();
    ctTask(const ctTask &);
    ctTask& operator= (const ctTask& elem);

    void importFEN(QString &input);
    void importEPD(QString &input);
    
    /** Position */
    ctPosition Position;
    /** Flag for printing the position */
    bool bDiagram;
    /** Title of the task */
    QString Title;
    /** Text of the task */
    QString Task;
    /** Text of the solution */
    QString Solution;

protected:

private:    
    void prepareMoveString(const QString &input, int tokStart,
                           QString &sToken);

};

#endif

